package javax.xml.bind;

import javax.xml.bind.attachment.AttachmentUnmarshaller;
import javax.xml.bind.annotation.adapters.XmlAdapter;
import javax.xml.validation.Schema;
import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamReader;
import javax.xml.transform.Source;
import org.w3c.dom.Node;
import org.xml.sax.InputSource;
import java.net.URL;
import java.io.Reader;
import java.io.InputStream;
import java.io.File;

public interface Unmarshaller
{
    public abstract Object unmarshal(File p0) throws JAXBException;
    
    public abstract Object unmarshal(InputStream p0) throws JAXBException;
    
    public abstract Object unmarshal(Reader p0) throws JAXBException;
    
    public abstract Object unmarshal(URL p0) throws JAXBException;
    
    public abstract Object unmarshal(InputSource p0) throws JAXBException;
    
    public abstract Object unmarshal(Node p0) throws JAXBException;
    
    public abstract <T> JAXBElement<T> unmarshal(Node p0, Class<T> p1) throws JAXBException;
    
    public abstract Object unmarshal(Source p0) throws JAXBException;
    
    public abstract <T> JAXBElement<T> unmarshal(Source p0, Class<T> p1) throws JAXBException;
    
    public abstract Object unmarshal(XMLStreamReader p0) throws JAXBException;
    
    public abstract <T> JAXBElement<T> unmarshal(XMLStreamReader p0, Class<T> p1) throws JAXBException;
    
    public abstract Object unmarshal(XMLEventReader p0) throws JAXBException;
    
    public abstract <T> JAXBElement<T> unmarshal(XMLEventReader p0, Class<T> p1) throws JAXBException;
    
    public abstract UnmarshallerHandler getUnmarshallerHandler();
    
    @Deprecated
    public abstract void setValidating(boolean p0) throws JAXBException;
    
    @Deprecated
    public abstract boolean isValidating() throws JAXBException;
    
    public abstract void setEventHandler(ValidationEventHandler p0) throws JAXBException;
    
    public abstract ValidationEventHandler getEventHandler() throws JAXBException;
    
    public abstract void setProperty(String p0, Object p1) throws PropertyException;
    
    public abstract Object getProperty(String p0) throws PropertyException;
    
    public abstract void setSchema(Schema p0);
    
    public abstract Schema getSchema();
    
    public abstract void setAdapter(XmlAdapter p0);
    
    public abstract <A extends XmlAdapter> void setAdapter(Class<A> p0, A p1);
    
    public abstract <A extends XmlAdapter> A getAdapter(Class<A> p0);
    
    public abstract void setAttachmentUnmarshaller(AttachmentUnmarshaller p0);
    
    public abstract AttachmentUnmarshaller getAttachmentUnmarshaller();
    
    public abstract void setListener(Unmarshaller.Listener p0);
    
    public abstract Unmarshaller.Listener getListener();
    
    public abstract static class Listener
    {
        public void beforeUnmarshal(Object target, Object parent) {
        }
        
        public void afterUnmarshal(Object target, Object parent) {
        }
    }
}
